moDraw.bga = {};

function moDraw.bga:setOpenPdaSlot(self, slot, slotName)	
	if slotName == "silagesilos" and moBgaMapObjects.silo == 0 or slotName == "bga" and moBgaMapObjects.catcher == 0 then
		moGuiExtras:closeOpenSlot(self, slot, true, false);
		g_currentMission:showBlinkingWarning(tostring(moLanguageXml:getTxt("slotno")), 2500);
		return;
	end;
	moGuiExtras:setSlotMaxProSwitch(self, slot);
	moGuiExtras:setSlotFirstEndObjects(self, slot);	
	local hotSpot = moGuiMiniPdaSlots.values[slot].hotSpot;
	local seeSmall = moGuiMiniPdaSlots.values[slot].seeSmall;
	if hotSpot then moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot = {};end;	
	if not seeSmall then moGuiMiniPdaSlots.values[slot].clickArea.slotSeeSmall = {};end;
	local posX = moGuiMiniPdaSlots.values[slot].openX+0.001;
	local posY = moGuiMiniPdaSlots.values[slot].openY;
	if g_seasons ~= nil and moGuiMiniPdaSlots.values[slot].seasonsAutoPos then
		if g_seasons.forecast.hud.visible then			
			if posY >= g_seasons.forecast.hud.posY and posX+moGuiMiniPdaSlots.values[slot].openLastWidth >= g_seasons.forecast.hud.posX then
				moGuiMiniPdaSlots.values[slot].openY = moGuiMiniPdaSlots.values[slot].openY - g_seasons.forecast.hud.overlays.forecast_hud.height / 2;
				posY = moGuiMiniPdaSlots.values[slot].openY;
				moMouseClickAreas:setSlotCfg(self, slot);
			end;			
		else
			if posY <= g_seasons.forecast.hud.posY and posX+moGuiMiniPdaSlots.values[slot].openLastWidth >= g_seasons.forecast.hud.posX then
				moGuiMiniPdaSlots.values[slot].openY = moGuiMiniPdaSlots.values[slot].openY + g_seasons.forecast.hud.overlays.forecast_hud.height / 2;
				posY = moGuiMiniPdaSlots.values[slot].openY;
				moMouseClickAreas:setSlotCfg(self, slot);
			end;			
		end;
	end;
	local size = moGuiMiniPdaSlots.values[slot].size;
	local distanceLine = moGuiMiniPdaSlots.values[slot].distanceLine;
	local widthSettings = moSetGetGui.buttonGfxWidth1*moSetGetGui.zoomOutInTemp*4;
	local heightSettings = moSetGetGui.buttonGfxHeight1*moSetGetGui.zoomOutInTemp*4;	
	local height = moSetGetGui.buttonGfxHeight1*(size*1000);
	local heightDefault = moSetGetGui.buttonGfxHeight1*(size*1000);
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	local width = slotLength+distanceDif;	
	--if moGuiMiniPdaSlots.values[slot].openX > 0.5 then posX = moGuiMiniPdaSlots.values[slot].openX-width+0.001;end;	
	local currentPosY = posY;
	function nextLine(setHeight, posYnew, setLine, posYline, widthLine, heightLine, onlyLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-0.001, currentPosY-(posYline), widthLine, heightLine);
			moSetGetGui["designLine"]:render();
			if onlyLine then return;end;
		end;		
		if setHeight then height = height+(heightDefault)+posYnew;end; --height+size+posNew;
		currentPosY = currentPosY-(heightDefault)-posYnew; --posY-(size+posYnew);		
	end;	
	moSetGetGui["designGround".. slot]:render();
	setTextBold(true);	
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	local sizeTemp = 0.010;
	if size < sizeTemp then sizeTemp = size;end;
	if moGuiMiniPdaSlots.keySwitchLast == slot then				
		if not moGuiMiniPdaSlots.values[slot].settings then
			moSetGetGui["slotCfg"]:setPosition(posX, posY);
			moSetGetGui["slotCfg"]:render();
		else
			moSetGetGui["slotPos"]:setPosition(posX, posY);
			moSetGetGui["slotPos"]:render();
		end;
		nextLine(true, 0.005, false);
		moSetGetGui["slotFruit"]:setPosition(posX+(widthSettings*1), posY);
		moSetGetGui["slotFruit"]:render();		
		if not moGuiMiniPdaSlots.values[slot].seeInOutFruit then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*1), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		moSetGetGui["slotMoney"]:setPosition(posX+(widthSettings*2), posY);
		moSetGetGui["slotMoney"]:render();		
		moSetGetGui["slotNotReady"]:setPosition(posX+(widthSettings*2), posY);
		moSetGetGui["slotNotReady"]:render();
		moSetGetGui["slotPlus"]:setPosition(posX+(widthSettings*3), posY);
		moSetGetGui["slotPlus"]:render();		
		if moGuiMiniPdaSlots.values[slot].seeSmall then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*3), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;		
		if not moGuiMiniPdaSlots.values[slot].hotSpot then
			moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotHotSpot"]:render();
			moSetGetGui["slotNotOkay"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotNotOkay"]:render();
		else
			if moGuiMiniPdaSlots.isHotSpotObj then
				if moGuiMiniPdaSlots.hotSpotBlinkTemp <= moGuiMiniPdaSlots.hotSpotBlinkTime then --warningBlinkTime, warningBlinkTemp
					moGuiMiniPdaSlots.hotSpotBlinkTemp = moGuiMiniPdaSlots.hotSpotBlinkTemp+1			
					moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
					moSetGetGui["slotHotSpot"]:render();			
				else
					moGuiMiniPdaSlots.hotSpotBlinkTemp = moGuiMiniPdaSlots.hotSpotBlinkTemp+1
					if moGuiMiniPdaSlots.hotSpotBlinkTemp >= moGuiMiniPdaSlots.hotSpotBlinkTime*2 then moGuiMiniPdaSlots.hotSpotBlinkTemp = 0;end;
				end;
			else
				moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
				moSetGetGui["slotHotSpot"]:render();
			end;
		end;
		if not moGuiMiniPdaSlots.combiBgaSilo then			
			moSetGetGui["slotSwitchL"]:setPosition(posX+(widthSettings*4), posY);
			moSetGetGui["slotSwitchL"]:render();
			renderText(posX+(widthSettings*4.7), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].switch));
			moSetGetGui["slotSwitchR"]:setPosition(posX+(widthSettings*5), posY);
			moSetGetGui["slotSwitchR"]:render();
			moSetGetGui["slotNextL"]:setPosition(posX+(widthSettings*6), posY);
			moSetGetGui["slotNextL"]:render();
			moSetGetGui["slotNextR"]:setPosition(posX+(widthSettings*8), posY);
			moSetGetGui["slotNextR"]:render();
			renderText(posX+(widthSettings*7.2), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].maxProSwitch));
		else			
			renderText(posX+(widthSettings*4.2), posY+0.0035, sizeTemp, tostring("max 11(no Switch)"));			
		end;			
	else
		moSetGetGui["slotNotReady"]:setPosition(posX, posY-(heightSettings));
		moSetGetGui["slotNotReady"]:render();
		nextLine(true, 0.005, false);
		renderText(posX, posY+0.0035, sizeTemp, "Slotname:  ".. tostring(moGuiMiniPdaSlots.values[slot].name));
	end;
	function setCatcherBgaExtensionValues1(a, name)
		if not moBgaMapObjects["catcher".. a].objCreate.fermenter_bioOK then setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));end;				
		renderText(posX, currentPosY, size, a.. ".".. name); --.. "(".. tostring(moBgaMapObjects["catcher".. a].speed).. ")");
		if hotSpot then moDraw.bga:setClickAreaHotSpot(self, posX, currentPosY, width/2, heightDefault, moBgaMapObjects["catcher".. a].x, moBgaMapObjects["catcher".. a].z, name, slot);end;
		nextLine(true, distanceLine, false);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_generator")));		
		setTextAlignment(2);
		setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
		local kw = string.format("%.1f", Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.printPower,0));
		renderText(posX+width-distanceDif, currentPosY, size, tostring(kw).. " kw");
		setTextAlignment(0);
		nextLine(true, distanceLine-0.001, false);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_feedingrate")));		
		setTextAlignment(2);
		setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
		local rate = string.format("%.1f", Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.bunkerFeedFactor,0)*100);
		renderText(posX+width-distanceDif, currentPosY, size, tostring(rate).. "%");
		setTextAlignment(0);
		
		nextLine(true, distanceLine, false);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_bunker")));
	end;
	function setCatcherBgaExtensionValues2(a)
		nextLine(true, distanceLine, false);			
		setTextBold(true);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_bunker")).. "-TS");
		setTextAlignment(2);
		setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
		local prozent = string.format("%.2f", Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.bunker_TS,0)*100);
		renderText(posX+width-distanceDif, currentPosY, size, tostring(prozent).. "%");		
		setTextAlignment(0);
		nextLine(true, distanceLine-0.001, false);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_fermenting")).. "-TS");
		setTextAlignment(2);
		setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
		prozent = string.format("%.2f", Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.fermenterTS,0)*100);
		renderText(posX+width-distanceDif, currentPosY, size, tostring(prozent).. "%");		
		setTextAlignment(0);
		nextLine(true, distanceLine, false);			
		if moBgaMapObjects["catcher".. a].objCreate.BGA_Bonus == 0 then --not moBgaMapObjects["catcher".. a].objCreate.bonusFillLevel
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_guellebonusno")));
		else
			setTextBold(false);
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor0));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_guellebonus")));
			setTextBold(false);
			setTextAlignment(2);
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			fillLevel = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.BGA_Bonus,0));
			capacity = g_i18n:formatNumber(Utils.getNoNil(moBgaMapObjects["catcher".. a].objCreate.BGA_Bonus_Capacity,0));
			local fillLevelString = "";
			local fillProzentString = "";
			if moGuiMiniPdaSlots.values[slot].seeFillLevel then fillLevelString = "|".. tostring(fillLevel).. "L";end;
			if moGuiMiniPdaSlots.values[slot].seeFillProzent and fillLevel ~= nil and capacity ~= nil and tonumber(capacity) > 0 then fillProzentString = "|".. string.format("%0.1f",Utils.getNoNil((tonumber(fillLevel)/tonumber(capacity)*100),0 )).. "%";end;
			
			renderText(posX+width-distanceDif, currentPosY, size, tostring(capacity).. tostring(fillLevelString).. tostring(fillProzentString));
			setTextAlignment(0);
		end;
	end;		
	function setBgas()		
		function getBgaSwitch()
			if moGuiMiniPdaSlots.combiBgaSilo then return 1, 4;end;
			return moGuiMiniPdaSlots.values[slot].firstObject, moGuiMiniPdaSlots.values[slot].endObject;
		end;
		local firstBgaDisplay, maxBgaDisplay = getBgaSwitch();					
		if moGuiMiniPdaSlots.values[slot].permUpdate and not moGuiMiniPdaSlots.combiBgaSilo then MultiOverlayV2:setSlotUpdate(self, slot);end;
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));	
		renderText(posX+(widthSettings*1.1), currentPosY, size, tostring(moLanguageXml:getTxt("b_bga")).. ": ".. tostring(firstBgaDisplay).. "-".. tostring(maxBgaDisplay));
		setTextAlignment(2);
		setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
		renderText(posX+width-distanceDif, currentPosY, size, tostring(moBgaMapObjects.catcher));		
		setTextAlignment(0);
		nextLine(true, 0.007, true, 0.0035, width, 0.001);
		if firstBgaDisplay <= moBgaMapObjects.catcher then
			for a=firstBgaDisplay, moBgaMapObjects.catcher do								
				if tonumber(a) > tonumber(maxBgaDisplay) then break;end;				
				setTextBold(true);				
				setTextColor(unpack(moGuiMiniPdaSlots.warningColor1));		
				local bgaName = moBgaMapObjects["catcher".. a].bgaName;		
				if moBgaMapObjects["catcher".. a].bgaExtension then --if moBgaMapObjects.bgaExtension and moBgaMapObjects["bgaExtension"..a] ~= nil then 
					setCatcherBgaExtensionValues1(a, bgaName)
				else
					renderText(posX, currentPosY, size, a.. ".".. tostring(bgaName)); --.. "(".. tostring(moBgaMapObjects["catcher".. a].speed).. ")");
					if hotSpot then moDraw.bga:setClickAreaHotSpot(self, posX, currentPosY, width/2, heightDefault, moBgaMapObjects["catcher".. a].x, moBgaMapObjects["catcher".. a].z, bgaName, slot);end;
					nextLine(true, distanceLine-0.001, false);
					setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
					renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_catcher")));
				end;		
				setTextBold(false);		
				setTextAlignment(2);
				setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
				local fillLevel = Utils.getNoNil(moBgaMapObjects["catcher".. a].fillLevel,0);
				local capacity = Utils.getNoNil(moBgaMapObjects["catcher".. a].capacity,0);
				--local fillLevel = string.format("%0.0f", Utils.getNoNil(moBgaMapObjects["catcher".. a].fillLevel, 0));
				if capacity ~= "nan" and capacity ~= "inf" then
					capacity = g_i18n:formatNumber(capacity);
				else
					capacity = 0;
				end;
				if fillLevel ~= "nan" and fillLevel ~= "inf" then
					fillLevel = g_i18n:formatNumber(fillLevel);
				else
					fillLevel = 0;
				end;
				local fillLevelString = "";
				local fillProzentString = "";
				if moGuiMiniPdaSlots.values[slot].seeFillLevel then fillLevelString = "|".. tostring(fillLevel).. "L";end;
				if moGuiMiniPdaSlots.values[slot].seeFillProzent and fillLevel ~= nil and capacity ~= nil and tonumber(capacity) > 0 then fillProzentString = "|".. string.format("%0.1f",Utils.getNoNil((tonumber(fillLevel)/tonumber(capacity)*100),0 )).. "%";end;
				renderText(posX+width-distanceDif, currentPosY, size, tostring(capacity).. tostring(fillLevelString).. tostring(fillProzentString));		
				setTextAlignment(0);
				if moGuiMiniPdaSlots.values[slot].seeInOutFruit then
					setTextAlignment(2);
					nextLine(true, distanceLine/3, false);		
					setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
					local stringLength = moSetGetGui.buttonGfxWidth1*(sizeTemp*1000/1.5)*(string.len(moBgaMapObjects["catcher".. a].fillType)/1.2+(moSetGetGui.screenAspectRatio));
					if tonumber(width) > tonumber(stringLength) then								
						if stringLength <= 0 then
							renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("unknow")));
						else
							renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(moBgaMapObjects["catcher".. a].fillType));
						end;
					else
						if not seeSmall then
							moDraw.bga:setClickAreaSeeSmall(self, posX, currentPosY-(0.0025), width, heightDefault, moBgaMapObjects["catcher".. a].fillType, tostring(bgaName), slot);
							moSetGetGui["slotPlus"]:setPosition(posX, currentPosY-(0.0025));
							moSetGetGui["slotPlus"]:render();
						end;
						local splitNames = Utils.splitString(",", moBgaMapObjects["catcher".. a].fillType)
						renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("toolong1")).. "(".. (table.getn(splitNames)-1).. " ".. tostring(moLanguageXml:getTxt("toolong2")).. ")");
					end;
				end;
				setTextAlignment(0);
				if moBgaMapObjects["catcher".. a].bgaExtension and moBgaMapObjects["catcher".. a].objCreate.fermenter_bioOK then --if moBgaMapObjects.bgaExtension and moBgaMapObjects["bgaExtension"..a] ~= nil and moBgaMapObjects["bgaExtension"..a].objCreate.fermenter_bioOK then
					setCatcherBgaExtensionValues2(a)
				end;		
				if moBgaMapObjects["catcher".. a].liquidManureFillLevel ~= -1 then						
					nextLine(true, distanceLine-0.001, false);
					setTextBold(true);
					setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
					renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("a_liquidmanure")));
					setTextBold(false);
					setTextAlignment(2);
					setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
					fillLevel = Utils.getNoNil(moBgaMapObjects["catcher".. a].liquidManureFillLevel,0);
					capacity = Utils.getNoNil(moBgaMapObjects["catcher".. a].liquidManureCapacity,0);
					if capacity ~= "nan" and capacity ~= "inf" then
						capacity = g_i18n:formatNumber(capacity);
					else
						capacity = 0;
					end;
					if fillLevel ~= "nan" and fillLevel ~= "inf" then
						fillLevel = g_i18n:formatNumber(fillLevel);
					else
						fillLevel = 0;
					end;
					--local fillLevel = string.format("%0.0f", Utils.getNoNil(moBgaMapObjects["catcher".. a].liquidManureFillLevel, 0));
					fillLevelString = "";
					fillProzentString = "";
					if moGuiMiniPdaSlots.values[slot].seeFillLevel then fillLevelString = "|".. tostring(fillLevel).. "L";end;
					if moGuiMiniPdaSlots.values[slot].seeFillProzent and 
					fillLevel ~= nil and 
					capacity ~= nil and type(capacity) == "tonumber"
					and tonumber(capacity) > 0 then 
					fillProzentString = "|".. string.format("%0.1f",Utils.getNoNil((tonumber(fillLevel)/tonumber(capacity)*100),0 )).. "%";
					end;
					renderText(posX+width-distanceDif, currentPosY, size, tostring(capacity).. tostring(fillLevelString).. tostring(fillProzentString));				
					setTextAlignment(0);
				end;
				if moBgaMapObjects["catcher".. a].digestateFillLevel ~= -1 then						
					nextLine(true, 0.007, true, 0.0035, width/3, 0.001);
					setTextBold(true);
					setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
					renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("a_digestate")));
					setTextBold(false);
					setTextAlignment(2);
					setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
					fillLevel = Utils.getNoNil(moBgaMapObjects["catcher".. a].digestateFillLevel,0);
					capacity = Utils.getNoNil(moBgaMapObjects["catcher".. a].digestateCapacity,0);
					if capacity ~= "nan" and capacity ~= "inf" then
						capacity = g_i18n:formatNumber(capacity);
					else
						capacity = 0;
					end;
					if fillLevel ~= "nan" and fillLevel ~= "inf" then
						fillLevel = g_i18n:formatNumber(fillLevel);
					else
						fillLevel = 0;
					end;
					--local fillLevel = string.format("%0.0f", Utils.getNoNil(moBgaMapObjects["catcher".. a].liquidManureFillLevel, 0));
					fillLevelString = "";
					fillProzentString = "";
					if moGuiMiniPdaSlots.values[slot].seeFillLevel then fillLevelString = "|".. tostring(fillLevel).. "L";end;
					if moGuiMiniPdaSlots.values[slot].seeFillProzent and fillLevel ~= nil and capacity ~= nil and tonumber(capacity) > 0 then fillProzentString = "|".. string.format("%0.1f",Utils.getNoNil((tonumber(fillLevel)/tonumber(capacity)*100),0 )).. "%";end;
					renderText(posX+width-distanceDif, currentPosY, size, tostring(capacity).. tostring(fillLevelString).. tostring(fillProzentString));				
					setTextAlignment(0);
				end;
				nextLine(true, 0.007, true, 0.0035, width, 0.001);				
			end;
		end;		
	end;
	function setSilageSilos()		
		function getBgaSilosSwitch()
			if moGuiMiniPdaSlots.combiBgaSilo then return 1, 7;end;
			return moGuiMiniPdaSlots.values[slot].firstObject, moGuiMiniPdaSlots.values[slot].endObject;				
		end;
		function setSiloPlane(ready)
			moSetGetGui["slotSiloPlane"]:setPosition(posX, currentPosY-(0.0045));
			moSetGetGui["slotSiloPlane"]:render();
			if not ready then
				moSetGetGui["slotNotOkay"]:setPosition(posX+0.002, currentPosY-(0.0025));
				moSetGetGui["slotNotOkay"]:render();
			end;
		end;
		local firstBgaSilosDisplay, maxBgaSilosDisplay = getBgaSilosSwitch();		
		if moGuiMiniPdaSlots.values[slot].permUpdate and not moGuiMiniPdaSlots.combiBgaSilo then MultiOverlayV2:setSlotUpdate(self, slot);end;
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));	
		renderText(posX+(widthSettings*1.1), currentPosY, size, tostring(moLanguageXml:getTxt("b_silos")).. ": ".. tostring(firstBgaSilosDisplay).. "-".. tostring(maxBgaSilosDisplay));
		setTextAlignment(2);
		setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
		renderText(posX+width-distanceDif, currentPosY, size, tostring(moBgaMapObjects.silo));		
		setTextAlignment(0);		
		nextLine(true, 0.007, true, 0.0035, width, 0.001);
		if firstBgaSilosDisplay <= moBgaMapObjects.silo then
			for a=firstBgaSilosDisplay, moBgaMapObjects.silo do
				local viewSilo = true;
				if moBgaMapObjects["silo".. a].isHeadyBGASilo ~= nil and moBgaMapObjects["silo".. a].isHeadyBGASilo and not moGuiMiniPdaSlots.headyBGASilo then
					viewSilo = false;					
				end;
				if tonumber(a) > tonumber(maxBgaSilosDisplay) then break;end;				
				setTextBold(true);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
				if moBgaMapObjects["silo".. a].siloName == nil then
					local siloType = " (".. moLanguageXml:getTxt("unknow").. ")";
					if moBgaMapObjects["silo".. a].movingPlanes <= 5 then siloType = " (".. moLanguageXml:getTxt("b_small").. ")";end;
					if moBgaMapObjects["silo".. a].movingPlanes > 5 and moBgaMapObjects["silo".. a].movingPlanes <= 10 then siloType = " (".. moLanguageXml:getTxt("b_middle").. ")";end;
					if moBgaMapObjects["silo".. a].movingPlanes > 10 and moBgaMapObjects["silo".. a].movingPlanes <= 15 then siloType = " (".. moLanguageXml:getTxt("b_large").. ")";end;
					if moBgaMapObjects["silo".. a].movingPlanes > 15 then siloType = " (".. moLanguageXml:getTxt("b_big").. ")";end;						
					if moBgaMapObjects["silo".. a].isHeadyBGASilo ~= nil and moBgaMapObjects["silo".. a].isHeadyBGASilo then
						renderText(posX, currentPosY, size, "Silo(H) ".. a.. tostring(siloType));
					else
						renderText(posX, currentPosY, size, "Silo ".. a.. tostring(siloType));
					end;
					if hotSpot then moDraw.bga:setClickAreaHotSpot(self, posX, currentPosY, width/2, heightDefault, moBgaMapObjects["silo".. a].x, moBgaMapObjects["silo".. a].z, "Silo"..a, slot);end;
				else
					renderText(posX, currentPosY, size, tostring(moBgaMapObjects["silo".. a].siloName));
					if hotSpot then moDraw.bga:setClickAreaHotSpot(self, posX, currentPosY, width/2, heightDefault, moBgaMapObjects["silo".. a].x, moBgaMapObjects["silo".. a].z, moBgaMapObjects["silo".. a].siloName, slot);end;
				end;					
				setTextBold(false);
				setTextAlignment(2);
				setTextColor(unpack(moGuiMiniPdaSlots.siloColor));				
				--local fillLevel = Utils.getNoNil(moBgaMapObjects["silo".. a].fillLevel,0);
				--local capacity = Utils.getNoNil(moBgaMapObjects["silo".. a].capacity,0);				 
				local capacity = string.format("%1.0f", Utils.getNoNil(moBgaMapObjects["silo".. a].capacity, 0));		
				local fillLevel = string.format("%1.0f", Utils.getNoNil(moBgaMapObjects["silo".. a].fillLevel, 0));
				--print("fillLevel...".. tostring(fillLevel).. "-- capacity...".. tostring(capacity))
				if capacity ~= "nan" and capacity ~= "inf" then
					capacity = g_i18n:formatNumber(tonumber(capacity));
				else
					capacity = 0;
				end;
				if fillLevel ~= "nan" and fillLevel ~= "inf" then
					fillLevel = g_i18n:formatNumber(tonumber(fillLevel));
				else
					fillLevel = 0;	
				end;				
				local fillProzent = 0;				
				if tonumber(fillLevel) and tonumber(capacity) and tonumber(fillLevel) ~= 0 and tonumber(capacity) ~= 0 then fillProzent = Utils.getNoNil(tonumber(fillLevel)/tonumber(capacity)*100, 0);end;				
				--local fillLevel = string.format("%0.0f", Utils.getNoNil(moBgaMapObjects["silo".. a].fillLevel, 0));				
				--setTextAlignment(0);		
				local state = moBgaMapObjects["silo".. a].state;				
				if moBgaMapObjects["silo".. a].isHeadyBGASilo ~= nil and moBgaMapObjects["silo".. a].isHeadyBGASilo then
					if tonumber(state) == 2 then
						--if moBgaMapObjects["silo".. a].objCreate.silo.outputFillType == FillUtil.FILLTYPE_MANURE then
						fillLevel = string.format("%1.0f", Utils.getNoNil(moBgaMapObjects["silo".. a].siloFillLevel, 0));
						if fillLevel ~= "nan" and fillLevel ~= "inf" then
							fillLevel = g_i18n:formatNumber(tonumber(fillLevel));
						else
							fillLevel = 0;	
						end;
					end;
				end;
				local fillLevelString = "";
				local fillProzentString = "";
				if moGuiMiniPdaSlots.values[slot].seeFillLevel then fillLevelString = "|".. tostring(fillLevel).. "L";end;
				if moGuiMiniPdaSlots.values[slot].seeFillProzent and fillLevel ~= nil and capacity ~= nil and tonumber(capacity) > 0 then fillProzentString = "|".. string.format("%0.1f",fillProzent).. "%";end;
				renderText(posX+width-distanceDif, currentPosY, size, tostring(capacity).. tostring(fillLevelString).. tostring(fillProzentString));				
				if tonumber(state) == 2 then			
					setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
					local stringLength = moSetGetGui.buttonGfxWidth1*(sizeTemp*1000/1.5)*(string.len(moBgaMapObjects["silo".. a].outPutFillType)/1.2+(moSetGetGui.screenAspectRatio));					
					if tonumber(width) > tonumber(stringLength) then
						setTextColor(unpack(moGuiMiniPdaSlots.warningColor0));
						if moBgaMapObjects.silageExtension then
							if tonumber(moBgaMapObjects["silo".. a].potatosFillLevel) > 0 then
								nextLine(true, distanceLine, false);
								setTextAlignment(0);
								setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
								renderText(posX, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("b_potatos")));
								setTextAlignment(2);
								setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
								local potatos = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].potatosFillLevel/fillLevel, 0)*100);
								renderText(posX+width-distanceDif, currentPosY, size, tostring(potatos).. "%");						
							end;
							if tonumber(moBgaMapObjects["silo".. a].grassFillLevel) > 0 then
								nextLine(true, distanceLine, false);
								setTextAlignment(0);
								setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
								renderText(posX, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("b_grass")));
								setTextAlignment(2);
								setTextColor(unpack(moGuiMiniPdaSlots.siloColor));						
								local grass = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].grassFillLevel/fillLevel, 0)*100);						
								renderText(posX+width-distanceDif, currentPosY, size, tostring(grass).. "%");						
							end;
							if tonumber(moBgaMapObjects["silo".. a].forageFillLevel) > 0 then
								nextLine(true, distanceLine, false);
								setTextAlignment(0);
								setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
								renderText(posX, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("b_forage")));
								setTextAlignment(2);
								setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
								local forage = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].forageFillLevel/fillLevel, 0)*100);
								renderText(posX+width-distanceDif, currentPosY, size, tostring(forage).. "%");						
							end;
							if not moBgaMapObjects["silo".. a].isRotten then
								if moGuiMiniPdaSlots.values[slot].seeInOutFruit then
									setTextAlignment(2);
									nextLine(true, distanceLine, false);
									renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(moBgaMapObjects["silo".. a].outPutFillType));
								end;
							else
								nextLine(true, distanceLine, false);
								--setTextAlignment(false)
								setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
								local fillLevel1 = string.format("%0.1f", Utils.getNoNil(moBgaMapObjects["silo".. a].rottenFillLevel/moBgaMapObjects["silo".. a].fillLevel,0)*100);
								renderText(posX, currentPosY, sizTemp, tostring(moLanguageXml:getTxt("b_rotten")).. " (".. fillLevel1.. "%)");									
								setTextAlignment(2);
								setTextColor(unpack(moGuiMiniPdaSlots.warningColor0));
								renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(moBgaMapObjects["silo".. a].outPutFillType));									
							end;
						else
							if moGuiMiniPdaSlots.values[slot].seeInOutFruit then								
								setTextAlignment(2);
								nextLine(true, distanceLine/3, false);
								renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(moBgaMapObjects["silo".. a].outPutFillType));
							end;
						end;
						setTextAlignment(0);
					else
						if moGuiMiniPdaSlots.values[slot].seeInOutFruit then
							if not seeSmall then
								moDraw.bga:setClickAreaSeeSmall(self, posX, currentPosY-(0.0025), width, heightDefault, moBgaMapObjects["silo".. a].outPutFillType, tostring("Silo".. a), slot);
								moSetGetGui["slotPlus"]:setPosition(posX, currentPosY-(0.0025));
								moSetGetGui["slotPlus"]:render();
							end;
							setTextAlignment(2);
							nextLine(true, distanceLine/3, false);
							local splitNames = Utils.splitString(",", moBgaMapObjects["silo".. a].outPutFillType)
							renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("toolong1")).. "(".. (table.getn(splitNames)-1).. " ".. tostring(moLanguageXml:getTxt("toolong2")).. ")");
						end;
					end;
				end;					
				if tonumber(state) == 0 then					
					if tonumber(moBgaMapObjects["silo".. a].potatosFillLevel) > 0 then
						nextLine(true, distanceLine, false);
						setTextAlignment(0);
						setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
						renderText(posX, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("b_potatos")));
						setTextAlignment(2);
						setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
						local potatos = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].potatosFillLevel/fillLevel, 0)*100);
						renderText(posX+width-distanceDif, currentPosY, size, tostring(potatos).. "%");
						setTextAlignment(0);
					end;
					if tonumber(moBgaMapObjects["silo".. a].grassFillLevel) > 0 then
						nextLine(true, distanceLine, false);
						setTextAlignment(0);
						setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
						renderText(posX, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("b_grass")));
						setTextAlignment(2);
						setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
						local grass = string.format("%0.2f", Utils.getNoNil(moBgaMapObjects["silo".. a].grassFillLevel/fillLevel, 0)*100);
						renderText(posX+width-distanceDif, currentPosY, size, tostring(grass).. "%");
						setTextAlignment(0);
					end;			
					if moGuiMiniPdaSlots.values[slot].seeInOutFruit then
						nextLine(true, distanceLine/3, false);
						setTextAlignment(2);
						setTextColor(unpack(moGuiMiniPdaSlots.activeColor));			
						local stringLength = moSetGetGui.buttonGfxWidth1*(sizeTemp*1000/1.5)*(string.len(moBgaMapObjects["silo".. a].fillType)/1.2+(moSetGetGui.screenAspectRatio));							
						if tonumber(width) > tonumber(stringLength) then								
							renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(moBgaMapObjects["silo".. a].fillType));
						else
							if not seeSmall then
								moDraw.bga:setClickAreaSeeSmall(self, posX, currentPosY-(0.0025), width, heightDefault, moBgaMapObjects["silo".. a].fillType, tostring("Silo".. a), slot);
								moSetGetGui["slotPlus"]:setPosition(posX, currentPosY-(0.0025));
								moSetGetGui["slotPlus"]:render();
							end;
							local splitNames = Utils.splitString(",", moBgaMapObjects["silo".. a].fillType)
							renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("toolong1")).. "(".. (table.getn(splitNames)-1).. " ".. tostring(moLanguageXml:getTxt("toolong2")).. ")");
						end;
					end;
				end;
				setTextAlignment(0);		
				if tonumber(state) == 1 then			
					nextLine(true, distanceLine, false);
					setTextBold(true);
					setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
					renderText(posX+(widthSettings*1.6), currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("b_fermenting")));
					setTextBold(false);
					setTextAlignment(2);
					setTextColor(unpack(moGuiMiniPdaSlots.siloColor));										
					local fermenting = string.format("%0.1f", Utils.getNoNil(moBgaMapObjects["silo".. a].fermentingTime/moBgaMapObjects["silo".. a].fermentingDuration*100, 0));
					if moBgaMapObjects["silo".. a].isHeadyBGASilo ~= nil and moBgaMapObjects["silo".. a].isHeadyBGASilo then						
						if not viewSilo then
							renderText(posX+width-distanceDif, currentPosY, size, tostring(moLanguageXml:getTxt("unknow")));
						else
							if moBgaMapObjects["silo".. a].fermenting then
								renderText(posX+width-distanceDif, currentPosY, size, tostring(100).. "%");
							else
								local fermentingEndTimeDays = Utils.getNoNil(moBgaMapObjects["silo".. a].fermentingDays,0)*24*3600000;
								local fermentingEndTimeHours = Utils.getNoNil(moBgaMapObjects["silo".. a].fermentingHours,0)*3600000;
								local test = fermentingEndTimeHours+fermentingEndTimeDays;
								local minutes = fermentingEndTimeHours - math.floor(fermentingEndTimeHours);
								local durationFermenting = fermentingEndTimeHours+fermentingEndTimeDays;
								local dayTime = g_currentMission.environment.dayTime;
								local endFermenting = g_currentMission.environment.currentDay*24*3600000+durationFermenting;
								local currentFermenting = g_currentMission.environment.currentDay*24*3600000+dayTime;								
								if g_currentMission.environment.currentDay >= moBgaMapObjects["silo".. a].fermentingTime then									
									--endFermenting = g_currentMission.environment.currentDay*24*3600000+(durationFermenting-(24*3600000));
									--dayTime = 0;									
								end;
								if g_currentMission.environment.dayTime >= fermentingEndTimeHours and g_currentMission.environment.currentDay < moBgaMapObjects["silo".. a].fermentingTime then
									--dayTime = g_currentMission.environment.dayTime;
								else
									--dayTime = g_currentMission.environment.dayTime;
								end;
								local test1 = durationFermenting;
								fermenting = moGuiExtras:getMilliSecondsToHours(test1, true);
								--renderText(posX+width-distanceDif, currentPosY, size, tostring(fermentingEndTimeDays*24).. ":".. tostring(fermentingEndTimeHours).. "h");
								renderText(posX+width-distanceDif, currentPosY, size, tostring(fermenting).. "h");								
							end;
						end;						
					else
						renderText(posX+width-distanceDif, currentPosY, size, tostring(fermenting).. "%");
					end;					
					setSiloPlane(true);
					setTextAlignment(0);
				end;					
				if tonumber(state) == 0 then
					nextLine(true, distanceLine, false);
					setTextBold(true);
					setTextColor(unpack(moGuiMiniPdaSlots.activeColor));		
					local compactPlane = Utils.getNoNil(moBgaMapObjects["silo".. a].compactFillLevel/moBgaMapObjects["silo".. a].fillLevel*100, 0);
					if compactPlane >= 98 and fillProzent >= 10 then
						setSiloPlane(true);
						renderText(posX+(widthSettings*1.6), currentPosY, size, tostring(moLanguageXml:getTxt("b_compact")));
					elseif fillProzent >= 10 then
						setSiloPlane(false);
						renderText(posX+(widthSettings*1.6), currentPosY, size, tostring(moLanguageXml:getTxt("b_compact")));
					else
						renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_compact")));
					end;					
					setTextBold(false);
					setTextAlignment(2);
					setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
					local compact = string.format("%0.1f", Utils.getNoNil(moBgaMapObjects["silo".. a].compactFillLevel/moBgaMapObjects["silo".. a].fillLevel*100, 0));
					renderText(posX+width-distanceDif, currentPosY, size, tostring(compact).. "%");
					setTextAlignment(0);			
				end;
				nextLine(true, 0.007, true, 0.0035, width, 0.001);				
			end;
		end;		
	end;
	if moGuiMiniPdaSlots.combiBgaSilo and moGuiMiniPdaSlots.values[slot].permUpdate then
		moSetGetBga:setBgaUpdate(self, MultiOverlayV2:getSlot("silagesilos"), "silagesilos");
		moSetGetBga:setBgaUpdate(self, MultiOverlayV2:getSlot("bga"), "bga");			
	end;
	if slotName == "bga" and not moGuiMiniPdaSlots.combiBgaSilo then setBgas();end;
	if slotName == "silagesilos" and not moGuiMiniPdaSlots.combiBgaSilo then setSilageSilos();end;
	if slotName == "bga" and moGuiMiniPdaSlots.combiBgaSilo then setBgas();setSilageSilos();end;
	if slotName == "silagesilos" and moGuiMiniPdaSlots.combiBgaSilo then setSilageSilos();setBgas();end;
	moSetGetGui:setOverlay(self, moSetGetGui["designGround".. slot], posX-0.001, currentPosY+(heightSettings/2), width, height+(heightSettings/2)); --+heightSettings	
	moGuiMiniPdaSlots.values[slot].openLastWidth = width;
	moGuiMiniPdaSlots.values[slot].openLastHeight = height+(heightSettings/2); --+heightSettings	
	setTextBold(false);	
end;

function moDraw.bga:setClickAreaHotSpot(self, posX, posY, horizontal, vertical, objX, objZ, name, slot)	
	if objX == nil or objZ == nil then return;end;
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), objX, objZ, name };
end;

function moDraw.bga:setClickAreaSeeSmall(self, posX, posY, horizontal, vertical, fillTypesString, name, slot)	
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotSeeSmall), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotSeeSmall[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), fillTypesString, name };
end;